diff --git a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
index 4e68c8573..99e2cdb82 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
@@ -1,15 +1,12 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.ServerCommandHandler;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.weather.Weather;
 
 public class WeatherCommand extends Command{
 
@@ -19,7 +16,9 @@ public class WeatherCommand extends Command{
 
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(args.length == 0) return false;
+		if(args.length == 0) {
+			return false;
+		}
 		
 		if(args[0].equals("list")) {
 			StringBuilder weatherString = new StringBuilder();
@@ -39,63 +38,45 @@ public class WeatherCommand extends Command{
 			return true;
 		}
 		
-		if(sender.isPlayer()) {
-			EntityPlayer player = sender.getPlayer();
-			
-			if(args[0].equals("next")) {
-				player.world.weatherManager.skip();
-				handler.sendCommandFeedback(sender, "Skipping to next weather");
-				return true;
-			}
-			else if (args[0].equals("set"))
-			{
-				int dimension = player.dimension;
-				Long duration = null;
-				Weather weather = null;
-				Float power = null;
-
-				World world = null;
-				if(handler instanceof ServerCommandHandler) {
-					ServerCommandHandler server = (ServerCommandHandler) handler;
-					world = server.minecraftServer.dimensionWorlds[dimension];
-				}
-				if(handler instanceof ClientCommandHandler) {
-					ClientCommandHandler client = (ClientCommandHandler) handler;
-					world = client.minecraft.theWorld;
-				}
-
-				if(world == null) return false;
-
-				weather = getWeather(args[1], world);
-				if(weather == null) throw new CommandError("Weather \""+args[1]+"\" doesn't exist!");
-
-				if(args.length >= 3) {
-					duration = Long.parseLong(args[2]) * 20;
-				}
-				if(args.length >= 4) {
-					power = Float.parseFloat(args[3]);
-				}
-
-				if (duration != null && power != null) {
-					world.weatherManager.overrideWeather(weather, duration, power);
-				} else if (duration != null) {
-					world.weatherManager.overrideWeather(weather, duration);
-				} else {
-					world.weatherManager.overrideWeather(weather);
-				}
-
-				handler.sendCommandFeedback(sender, TextFormatting.LIGHT_GRAY + "Changing weather to " + TextFormatting.WHITE + weather.getLanguageKey().substring(8));
-
-				return true;
-			}
-			else
-			{
-				return false;
-			}
+		World world = sender.getWorld();
+		if(args[0].equals("next")) {
+			world.weatherManager.skip();
+			handler.sendCommandFeedback(sender, "Skipping to next weather");
+			return true;
+		}
+		
+		int offset = 0;
+		if(args[0].equals("set")) {
+			offset = 1;
+		}
+		
+		String weatherId = args[offset];
+		Weather weather = getWeather(weatherId, world);
+		if(weather == null) {
+			throw new CommandError("Weather \"" + weatherId + "\" doesn't exist!");
+		}
+		
+		Long duration = null;
+		if(args.length > offset + 1) {
+			duration = Long.parseLong(args[offset + 1]) * 20;
+		}
+		
+		Float power = null;
+		if(args.length > offset + 2) {
+			power = Float.parseFloat(args[offset + 2]);
+		}
 
+		if(duration != null && power != null) {
+			world.weatherManager.overrideWeather(weather, duration, power);
+		}else if(duration != null) {
+			world.weatherManager.overrideWeather(weather, duration);
 		}else {
-			return false;
+			world.weatherManager.overrideWeather(weather);
 		}
+		
+		handler.sendCommandFeedback(sender, TextFormatting.LIGHT_GRAY + "Changing weather to " + TextFormatting.WHITE + weather.getLanguageKey().substring(8));
+		
+		return true;
 	}
 
 	@Override
@@ -106,28 +87,25 @@ public class WeatherCommand extends Command{
 	@Override
 	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
 		sender.sendMessage("/weather list");
-		if(sender.isPlayer()) {
-			sender.sendMessage("/weather next");
-			sender.sendMessage("/weather set <weather> [duration (sec)] [power (0.0-1.0)]");
-		}
+		sender.sendMessage("/weather next");
+		sender.sendMessage("/weather set <weather> [duration (sec)] [power (0.0-1.0)]");
+		sender.sendMessage("/weather <weather> [duration (sec)] [power (0.0-1.0)]");
 	}
 	
 	public static Weather getWeather(String string, World world) {
 		try {
-			try {
-				return Weather.getWeather(Integer.parseInt(string));
-			}catch (Exception e) {}
-			
-			if(string.equalsIgnoreCase("clear")) {
-				Weather w = world.worldType.getDefaultWeather();
-				if(w == null) throw new CommandError("Dimension "+world.dimension.getTranslatedName()+" does not have a default weather!");
-				return w;
+			return Weather.getWeather(Integer.parseInt(string));
+		}catch (NumberFormatException e) {}
+
+		if(string.equalsIgnoreCase("clear")) {
+			Weather weather = world.worldType.getDefaultWeather();
+			if(weather == null) {
+				throw new CommandError("Dimension " + world.dimension.getTranslatedName() + " does not have a default weather!");
 			}
-			
-			return Weather.getWeatherByLanguageKey(string);
-		}catch (Exception e) {
-			throw new RuntimeException(e);
+			return weather;
 		}
+		
+		return Weather.getWeatherByLanguageKey(string);
 	}
 
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java b/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java
index 0e6b51677..188d58772 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.packet;
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.NetHandler;
 
@@ -16,13 +17,13 @@ public class Packet104WindowItems extends Packet
     {
     }
     
-    public Packet104WindowItems(int i, List list)
+    public Packet104WindowItems(int i, List<ItemStack> list)
     {
         windowId = i;
         itemStack = new ItemStack[list.size()];
         for(int j = 0; j < itemStack.length; j++)
         {
-            ItemStack itemstack = (ItemStack)list.get(j);
+            ItemStack itemstack = list.get(j);
             itemStack[j] = itemstack != null ? itemstack.copy() : null;
         }
 
@@ -42,7 +43,11 @@ public class Packet104WindowItems extends Packet
             {
                 byte byte0 = dis.readByte();
                 short word2 = dis.readShort();
-                itemStack[i] = new ItemStack(word1, byte0, word2);
+                CompoundTag tag = null;
+                if (dis.readByte() == 1){
+                    tag = readCompressedCompoundTag(dis);
+                }
+                itemStack[i] = new ItemStack(word1, byte0, word2, tag);
             }
         }
 
@@ -64,6 +69,12 @@ public class Packet104WindowItems extends Packet
                 dos.writeShort((short)itemStack[i].itemID);
                 dos.writeByte((byte)itemStack[i].stackSize);
                 dos.writeShort((short)itemStack[i].getMetadata());
+                if (!itemStack[i].getData().getValues().isEmpty()){
+                    dos.writeByte(0);
+                } else {
+                    dos.writeByte(1);
+                    writeCompressedCompoundTag(itemStack[i].getData(), dos);
+                }
             }
         }
 
@@ -82,5 +93,5 @@ public class Packet104WindowItems extends Packet
     }
 
     public int windowId;
-    public ItemStack itemStack[];
+    public ItemStack[] itemStack;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java b/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java
index c4229c07b..a60b3b05f 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java
@@ -27,7 +27,7 @@ public class Packet255KickDisconnect extends Packet
 	public void readPacketData(DataInputStream dis)
         throws IOException
     {
-        reason = readUTF16BEString(dis, 200);
+        reason = readUTF16BEString(dis, 255);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 28423c816..621d320b8 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1029,6 +1029,7 @@ public class World implements WorldSource {
         }
     }
 
+    @Override
     public int getSavedLightValue(LightLayer layer, int x, int y, int z)
     {
         if(y < 0)
diff --git a/src/main/java/net/minecraft/core/world/WorldSource.java b/src/main/java/net/minecraft/core/world/WorldSource.java
index 10699959d..e5843d29c 100644
--- a/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.season.SeasonManager;
 
@@ -32,4 +33,6 @@ public interface WorldSource
     double getBlockHumidity(int x, int z);
     SeasonManager getSeasonManager();
     Biome getBlockBiome(int x, int y, int z);
+    
+    public int getSavedLightValue(LightLayer layer, int x, int y, int z);
 }
diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 6df483bca..12e736592 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -17,7 +17,7 @@ public class Biomes
     public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
     public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm).setTopBlock(Block.sand.id).setFillerBlock(Block.sand.id));
-    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomeForest("plains").setColor(0xA3C649));
+    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
     public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Block.blockSnow.id).setFillerBlock(Block.blockSnow.id));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("meadow").setColor(0x8c8c22));
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 86b6079a2..bd0db92c0 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -276,4 +276,9 @@ public class ChunkCache
     public Biome getBlockBiome(int x, int y, int z) {
         return worldObj.getBlockBiome(x, y, z);
     }
+
+	@Override
+	public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
+		return worldObj.getSavedLightValue(layer, x, y, z);
+	}
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
index 99907a0a3..191d15527 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
@@ -62,6 +62,7 @@ public class WorldFeatureTreeThorn extends WorldFeatureSpoonerTreeProcedural {
             } else {
                 branchY = posY - dist * slope;
             }
+            branchY = Math.max(branchY, pos[1]);
             int[] startCoord = new int[] { treePosition[0], (int) branchY, treePosition[2]};
             taperedLimb(startCoord, coord, 1.0, 1.0, world);
         }
diff --git a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
index 95cb97222..e3beb7d28 100644
--- a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
+++ b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
@@ -788,14 +788,14 @@ public class EntityPlayerMP extends EntityPlayer
     }
 
     @Override
-	public void updateCraftingInventory(Container container, List list)
+	public void updateCraftingInventory(Container container, List<ItemStack> list)
     {
 
         //playernetserverhandler returning false?
         if (playerNetServerHandler != null)
         {
             playerNetServerHandler.sendPacket(new Packet104WindowItems(container.windowId, list));
-            playerNetServerHandler.sendPacket(new Packet103SetSlot(-1, -1, inventory.getHeldItemStack()));
+//            playerNetServerHandler.sendPacket(new Packet103SetSlot(-1, -1, inventory.getHeldItemStack()));
         }
     }
 
diff --git a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
index 5fdb32b64..ba3bee281 100644
--- a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
+++ b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
@@ -61,6 +61,7 @@ public class ConsoleCommandHandler
     			return true;
     		}
     	}
+        sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
     	
     	return false;
     }
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index ad272edd0..cc66f95cf 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -16,6 +16,7 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.save.PlayerIO;
 import net.minecraft.server.MinecraftServer;
 import org.apache.log4j.Logger;
+import org.jetbrains.annotations.Nullable;
 
 
 import java.io.*;
@@ -515,7 +516,7 @@ public class PlayerList
     {
         return ops.contains(s.trim().toLowerCase());
     }
-
+    @Nullable
     public EntityPlayerMP getPlayerEntity(String s)
     {
         for (int i = 0; i < playerEntities.size(); i++)
diff --git a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
index 72d01acde..6e1ec53c4 100644
--- a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
@@ -534,7 +534,7 @@ public class NetServerHandler extends NetHandler
 		}
 		
 		message = message.trim();
-		message = message.replace('\u00A7', '$');
+//		message = message.replace('\u00A7', '$');
 		
 		for(int i = 0; i < message.length(); i++) {
 			char c = message.charAt(i);
@@ -771,10 +771,10 @@ public class NetServerHandler extends NetHandler
                 field_10_k.put(Integer.valueOf(playerEntity.craftingInventory.windowId), Short.valueOf(packet.actionId));
                 playerEntity.playerNetServerHandler.sendPacket(new Packet106Transaction(packet.window_Id, packet.actionId, false));
                 playerEntity.craftingInventory.setCanCraft(playerEntity, false);
-                ArrayList arraylist = new ArrayList();
+                ArrayList<ItemStack> arraylist = new ArrayList<>();
                 for (int i = 0; i < playerEntity.craftingInventory.inventorySlots.size(); i++)
                 {
-                    arraylist.add(((Slot) playerEntity.craftingInventory.inventorySlots.get(i)).getStack());
+                    arraylist.add(playerEntity.craftingInventory.inventorySlots.get(i).getStack());
                 }
 
                 playerEntity.updateCraftingInventory(playerEntity.craftingInventory, arraylist);
@@ -934,6 +934,6 @@ public class NetServerHandler extends NetHandler
     private double lastPosY;
     private double lastPosZ;
     private boolean hasMoved;
-    private Map field_10_k;
+    private final Map<Integer, Short> field_10_k;
 
 }
